inline CMSSignatureOptions::~CMSSignatureOptions()
{
	Destroy();
}

inline CMSSignatureOptions::CMSSignatureOptions(const CMSSignatureOptions& other)
	: m_impl(other.m_impl)
	, m_owner(false)
{
	if (other.m_owner) {
		other.m_owner = false;
		m_owner = true;
	}
}

inline void CMSSignatureOptions::Destroy()
{
	if (m_owner)
	{
		//DREX(m_impl, TRN_CMSSignatureOptionsDestroy(m_impl));
		m_impl = 0;
		m_owner = false;
	}
}

inline CMSSignatureOptions& CMSSignatureOptions::operator= (const CMSSignatureOptions& other)
{
	Destroy();

	m_impl = other.m_impl;

	if (other.m_owner) {
		other.m_owner = false;
		m_owner = true;
	}

	return *this;
}

inline CMSSignatureOptions::CMSSignatureOptions()
	: m_impl(0)
	, m_owner(false)
{}

inline CMSSignatureOptions::CMSSignatureOptions(TRN_CMSSignatureOptions impl)
	: m_impl(impl)
	, m_owner(true)
{}
