// This file is autogenerated: please see the codegen template "Options"
#ifndef PDFTRON_H_CPPPDFOfficeToPDFOptions
#define PDFTRON_H_CPPPDFOfficeToPDFOptions

#include <PDF/ConversionOptions.h>

namespace pdftron{ namespace PDF{ 

class OfficeToPDFOptions : public ConversionOptions
{
public:
	OfficeToPDFOptions();
	~OfficeToPDFOptions();

	/**
	 * Level of detail for structure tags.
	 */
	enum StructureTagLevel
	{
		e_default = 0, ///< Default level of structure tags, good for accessibility.
		e_none = 1, ///< No structure tags.  This can be used to get smaller file sizes.
	};
	
	/**
	* Gets the value ApplyPageBreaksToSheet from the options object
	* Whether we should split Excel workheets into pages so that the output resembles print output. If set to false (the default), Excel sheets will be placed one per page, except in the case where the sheets are very large
	* @return a bool, the current value for ApplyPageBreaksToSheet.
	*/
	bool GetApplyPageBreaksToSheet();

	/**
	* Sets the value for ApplyPageBreaksToSheet in the options object
	* Whether we should split Excel workheets into pages so that the output resembles print output. If set to false (the default), Excel sheets will be placed one per page, except in the case where the sheets are very large
	* @param value: the new value for ApplyPageBreaksToSheet
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetApplyPageBreaksToSheet(bool value);

	
	/**
	* Gets the value DisplayChangeTracking from the options object
	* If this option is true, will display office change tracking markup present in the document (i.e, red strikethrough of deleted content and underlining of new content). Otherwise displays the resolved document content, with no markup. Defaults to true.
	* @return a bool, the current value for DisplayChangeTracking.
	*/
	bool GetDisplayChangeTracking();

	/**
	* Sets the value for DisplayChangeTracking in the options object
	* If this option is true, will display office change tracking markup present in the document (i.e, red strikethrough of deleted content and underlining of new content). Otherwise displays the resolved document content, with no markup. Defaults to true.
	* @param value: the new value for DisplayChangeTracking
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetDisplayChangeTracking(bool value);

	
	/**
	* Gets the value DisplayHiddenText from the options object
	* Display any hidden text that is present in the document (i.e., text that has been marked as 'Hidden' in the font style). By default, hidden text will not be displayed.
	* @return a bool, the current value for DisplayHiddenText.
	*/
	bool GetDisplayHiddenText();

	/**
	* Sets the value for DisplayHiddenText in the options object
	* Display any hidden text that is present in the document (i.e., text that has been marked as 'Hidden' in the font style). By default, hidden text will not be displayed.
	* @param value: the new value for DisplayHiddenText
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetDisplayHiddenText(bool value);

	
	/**
	* Gets the value ExcelDefaultCellBorderWidth from the options object
	* Cell border width for table cells that would normally be drawn with no border. In units of points. Can be used to achieve a similar effect to the "show gridlines" display option within Microsoft Excel.
	* @return a double, the current value for ExcelDefaultCellBorderWidth.
	*/
	double GetExcelDefaultCellBorderWidth();

	/**
	* Sets the value for ExcelDefaultCellBorderWidth in the options object
	* Cell border width for table cells that would normally be drawn with no border. In units of points. Can be used to achieve a similar effect to the "show gridlines" display option within Microsoft Excel.
	* @param value: the new value for ExcelDefaultCellBorderWidth
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetExcelDefaultCellBorderWidth(double value);

	
	/**
	* Gets the value ExcelMaxAllowedCellCount from the options object
	* Conversion will throw an exception if the number of cells in a Microsoft Excel document is above the set MaxAllowedCellCount. Used for early termination of resource intensive conversions. Setting this value to 250000 will allow the vast majority of Excel documents to convert without issue, while keeping RAM usage to a reasonable level. By default there is no limit to the number of allowed cells.
	* @return a UInt32, the current value for ExcelMaxAllowedCellCount.
	*/
	UInt32 GetExcelMaxAllowedCellCount();

	/**
	* Sets the value for ExcelMaxAllowedCellCount in the options object
	* Conversion will throw an exception if the number of cells in a Microsoft Excel document is above the set MaxAllowedCellCount. Used for early termination of resource intensive conversions. Setting this value to 250000 will allow the vast majority of Excel documents to convert without issue, while keeping RAM usage to a reasonable level. By default there is no limit to the number of allowed cells.
	* @param value: the new value for ExcelMaxAllowedCellCount
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetExcelMaxAllowedCellCount(UInt32 value);

	
	/**
	* Gets the value HideTotalNumberOfPages from the options object
	* If the document has an element that displays the total number of pages and the total number of pages is unknown beforehand, remove those elements from the document.
	* @return a bool, the current value for HideTotalNumberOfPages.
	*/
	bool GetHideTotalNumberOfPages();

	/**
	* Sets the value for HideTotalNumberOfPages in the options object
	* If the document has an element that displays the total number of pages and the total number of pages is unknown beforehand, remove those elements from the document.
	* @param value: the new value for HideTotalNumberOfPages
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetHideTotalNumberOfPages(bool value);

	
	/**
	* Gets the value IncludeBookmarks from the options object
	* When this option is set to false, Word document bookmarks will not be converted into PDF bookmarks. However, Word headings will still be automatically converted into PDF bookmarks. By default, both Word bookmarks and headings are converted into PDF bookmarks, providing a comprehensive navigation structure within the converted PDF.
	* @return a bool, the current value for IncludeBookmarks.
	*/
	bool GetIncludeBookmarks();

	/**
	* Sets the value for IncludeBookmarks in the options object
	* When this option is set to false, Word document bookmarks will not be converted into PDF bookmarks. However, Word headings will still be automatically converted into PDF bookmarks. By default, both Word bookmarks and headings are converted into PDF bookmarks, providing a comprehensive navigation structure within the converted PDF.
	* @param value: the new value for IncludeBookmarks
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetIncludeBookmarks(bool value);

	
	/**
	* Gets the value IncrementalSave from the options object
	* If this option is true, the document will be saved incrementally during the conversion, thus reducing the peak memory usage. Save an empty PDFDoc to the target location before the conversion so the incremental saving is done directly to the target location. Otherwise, a temporary file will be used. PDFDoc.Save still has to be called after the conversion is done to finalize the file. Doing PDFDoc.Save with e_incremental flag will reduce the saving time but increase the PDF file size.
	* @return a bool, the current value for IncrementalSave.
	*/
	bool GetIncrementalSave();

	/**
	* Sets the value for IncrementalSave in the options object
	* If this option is true, the document will be saved incrementally during the conversion, thus reducing the peak memory usage. Save an empty PDFDoc to the target location before the conversion so the incremental saving is done directly to the target location. Otherwise, a temporary file will be used. PDFDoc.Save still has to be called after the conversion is done to finalize the file. Doing PDFDoc.Save with e_incremental flag will reduce the saving time but increase the PDF file size.
	* @param value: the new value for IncrementalSave
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetIncrementalSave(bool value);

	
	/**
	* Gets the value LayoutResourcesPluginPath from the options object
	* The path at which the pdftron-provided font resource plugin resides
	* @return a UString, the current value for LayoutResourcesPluginPath.
	*/
	UString GetLayoutResourcesPluginPath();

	/**
	* Sets the value for LayoutResourcesPluginPath in the options object
	* The path at which the pdftron-provided font resource plugin resides
	* @param value: the new value for LayoutResourcesPluginPath
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetLayoutResourcesPluginPath(const UString& value);

	
	/**
	* Gets the value Locale from the options object
	* ISO 639-1 code of the locale to be applied during conversion. For example: 'en-US', 'ar-SA', 'de-DE', etc. Currently only applied during xls/xlsx conversions.
	* @return a UString, the current value for Locale.
	*/
	UString GetLocale();

	/**
	* Sets the value for Locale in the options object
	* ISO 639-1 code of the locale to be applied during conversion. For example: 'en-US', 'ar-SA', 'de-DE', etc. Currently only applied during xls/xlsx conversions.
	* @param value: the new value for Locale
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetLocale(const UString& value);

	
	/**
	* Gets the value Password from the options object
	* Password used to decrypt password-protected office documents.
	* @return a UString, the current value for Password.
	*/
	UString GetPassword();

	/**
	* Sets the value for Password in the options object
	* Password used to decrypt password-protected office documents.
	* @param value: the new value for Password
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetPassword(const UString& value);

	
	/**
	* Gets the value ResourceDocPath from the options object
	* The path at which a .docx resource document resides
	* @return a UString, the current value for ResourceDocPath.
	*/
	UString GetResourceDocPath();

	/**
	* Sets the value for ResourceDocPath in the options object
	* The path at which a .docx resource document resides
	* @param value: the new value for ResourceDocPath
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetResourceDocPath(const UString& value);

	
	/**
	* Gets the value SmartSubstitutionPluginPath from the options object
	* The path at which the pdftron-provided font resource plugin resides
	* @return a UString, the current value for SmartSubstitutionPluginPath.
	*/
	UString GetSmartSubstitutionPluginPath();

	/**
	* Sets the value for SmartSubstitutionPluginPath in the options object
	* The path at which the pdftron-provided font resource plugin resides
	* @param value: the new value for SmartSubstitutionPluginPath
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetSmartSubstitutionPluginPath(const UString& value);

	
	/**
	* Gets the value StructureTagLevel from the options object
	* Specifies the level of document structure tags to include in the PDF for accessibility purposes.
	* @return a StructureTagLevel, the current value for StructureTagLevel.
	*/
	StructureTagLevel GetStructureTagLevel();

	/**
	* Sets the value for StructureTagLevel in the options object
	* Specifies the level of document structure tags to include in the PDF for accessibility purposes.
	* @param value: the new value for StructureTagLevel
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetStructureTagLevel(StructureTagLevel value);

	
	/**
	* Gets the value TemplateLeftDelimiter from the options object
	* Left delimiter for template tags.  Defaults to '{{'.
	* @return a UString, the current value for TemplateLeftDelimiter.
	*/
	UString GetTemplateLeftDelimiter();

	/**
	* Sets the value for TemplateLeftDelimiter in the options object
	* Left delimiter for template tags.  Defaults to '{{'.
	* @param value: the new value for TemplateLeftDelimiter
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetTemplateLeftDelimiter(const UString& value);

	
	/**
	* Gets the value TemplateParamsJson from the options object
	* JSON string representing the data to be merged into a PDFTron office template.  For a more featureful template API, see CreateOfficeTemplate.
	* @return a UString, the current value for TemplateParamsJson.
	*/
	UString GetTemplateParamsJson();

	/**
	* Sets the value for TemplateParamsJson in the options object
	* JSON string representing the data to be merged into a PDFTron office template.  For a more featureful template API, see CreateOfficeTemplate.
	* @param value: the new value for TemplateParamsJson
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetTemplateParamsJson(const UString& value);

	
	/**
	* Gets the value TemplateRightDelimiter from the options object
	* Right delimiter for template tags.  Defaults to '}}'.
	* @return a UString, the current value for TemplateRightDelimiter.
	*/
	UString GetTemplateRightDelimiter();

	/**
	* Sets the value for TemplateRightDelimiter in the options object
	* Right delimiter for template tags.  Defaults to '}}'.
	* @param value: the new value for TemplateRightDelimiter
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetTemplateRightDelimiter(const UString& value);

	
	/**
	* Gets the value TemplateStrictMode from the options object
	* If "Strict Mode" is enabled, when a template key is missing from the json data an exception will be thrown.  If "Strict Mode" is disabled (default), the tag will be replaced with no content.
	* @return a bool, the current value for TemplateStrictMode.
	*/
	bool GetTemplateStrictMode();

	/**
	* Sets the value for TemplateStrictMode in the options object
	* If "Strict Mode" is enabled, when a template key is missing from the json data an exception will be thrown.  If "Strict Mode" is disabled (default), the tag will be replaced with no content.
	* @param value: the new value for TemplateStrictMode
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetTemplateStrictMode(bool value);

	
	/**
	* Gets the value UpdateTableOfContents from the options object
	* Updates the table of contents in the document so it matches the actual locations of headings/bookmarks. By default, the table of contents is not updated. Enabling this option may negatively affect conversion speed.
	* @return a bool, the current value for UpdateTableOfContents.
	*/
	bool GetUpdateTableOfContents();

	/**
	* Sets the value for UpdateTableOfContents in the options object
	* Updates the table of contents in the document so it matches the actual locations of headings/bookmarks. By default, the table of contents is not updated. Enabling this option may negatively affect conversion speed.
	* @param value: the new value for UpdateTableOfContents
	* @return this object, for call chaining
	*/
	OfficeToPDFOptions& SetUpdateTableOfContents(bool value);

	
};

}
}

#include "../Impl/OfficeToPDFOptions.inl"
#endif // PDFTRON_H_CPPPDFOfficeToPDFOptions
